// -------------------------------------------------------------------------------
// 
// 		cwCu		WindowspVXevO
// 
// 				Ver 3.20c
// 
// -------------------------------------------------------------------------------

// cwCu쐬p`
#define __DX_MAKE

#include "DxSystemWin.h"

// CN[h ------------------------------------------------------------------
#include "DxWindow.h"
#include "DxGraphicsWin.h"
#include "../DxLib.h"
#include "../DxSystem.h"
#include "../DxArchive_.h"
#include "../DxGraphics.h"
#include "../DxModel.h"
#include "../DxFile.h"
#include "../DxNetwork.h"
#include "../DxInputString.h"
#include "../DxInput.h"
#include "../DxSound.h"
#include "../DxSoundConvert.h"
#include "../DxBaseImage.h"
#include "../DxSoftImage.h"
#include "../DxMovie.h"
#include "../DxFont.h"
#include "../DxLog.h"
#include "../DxASyncLoad.h"
#include "../DxUseCLib.h"


#include "../DxBaseFunc.h"
#include "../DxMemory.h"
#include "DxWindow.h"
#include "DxWinAPI.h"
#include "DxGuid.h"


#ifndef DX_NON_NAMESPACE

namespace DxLib
{

#endif // DX_NON_NAMESPACE

// }N` --------------------------------------------------------------------

//#define MAX_EVENTPROCESS_NUM						(5)					// xɏCxg̍ő吔

// \̒` --------------------------------------------------------------------

// e[u-----------------------------------------------------------------------

// ϐ錾 --------------------------------------------------------------

// ֐vg^Cv錾-----------------------------------------------------------

// vO --------------------------------------------------------------------

// Cu֐
extern int NS_DxLib_Init( void )
{
	// ɏς݂̏ꍇ͉I
	if( DxSysData.DxLib_InitializeFlag == TRUE ) return 0 ;

	DXST_LOGFILEFMT_ADDUTF16LE(( "\x24\xff\x38\xff\xe9\x30\xa4\x30\xd6\x30\xe9\x30\xea\x30\x6e\x30\x1d\x52\x1f\x67\x16\x53\xe6\x51\x06\x74\x8b\x95\xcb\x59\x00"/*@ L"cwCȕJn" @*/ )) ;
	DXST_LOGFILE_TABADD ;

	SETUP_WIN_API

	// tO𗧂Ă
	DxSysData.DxLib_RunInitializeFlag = TRUE ;

	// QuitMessage ΂tO|
	WinData.QuitMessageFlag = FALSE ;

	// DxSysData ̋ʏ
	DxLib_SysInit() ;

	// LN^[R[h֌W̏s
	InitCharCode() ;

	// DxBaseFunc ̏
	_INIT_BASEFUNC() ;

	// gp镶ZbgZbg
	_SET_DEFAULT_CHARCODEFORMAT() ;

#ifndef DX_NON_OGGTHEORA
	// Theora p̏
	TheoraDecode_GrobalInitialize() ;
#endif

	// A[JCut@CANZXp̃f[^
#ifndef DX_NON_DXA
	DXA_DIR_Initialize() ;
#endif

	// Xg[f[^ǂݍݐp|C^\̂̃ftHglZbg
	NS_ChangeStreamFunction( NULL ) ;

	// JgfBNgۑ
	DX_FGETDIR( WinData.CurrentDirectory, sizeof( WinData.CurrentDirectory ) ) ; 

#ifndef DX_NON_LOG
	// Ot@C̏
	LogFileInitialize() ;
#endif

#ifndef DX_NON_GRAPHICS

	// tXN[[h̏ꍇ͎w̉ʉ𑜓xgp\ǂ𒲂ׂ
	if( WinData.WindowModeFlag == FALSE )
	{
		int Num, i, Width, Height, ColorBitDepth ;
		int DisplayIndex ;
		DISPLAYMODEDATA Mode ;

SCREENMODECHECK:
		ColorBitDepth = NS_GetColorBitDepth() ;
		NS_GetDrawScreenSize( &Width, &Height ) ; 

		DXST_LOGFILEFMT_ADDUTF16LE(( "\x2d\x8a\x9a\x5b\x55\x30\x8c\x30\x66\x30\x44\x30\x8b\x30\x3b\x75\x62\x97\x2d\x8a\x9a\x5b\x20\x00\x25\x00\x64\x00\x78\x00\x25\x00\x64\x00\x20\x00\x25\x00\x64\x00\x62\x00\x69\x00\x74\x00\x20\x00\x63\x00\x6f\x00\x6c\x00\x6f\x00\x72\x00\x00"/*@ L"ݒ肳Ăʐݒ %dx%d %dbit color" @*/, Width, Height, ColorBitDepth ) ) ;

		DisplayIndex = GSYS.Screen.ValidUseDisplayIndex ? GSYS.Screen.UseDisplayIndex : 0 ;

		Num = NS_GetDisplayModeNum( DisplayIndex ) ;
		for( i = 0 ; i < Num ; i ++ )
		{
			Mode = NS_GetDisplayMode( i, DisplayIndex ) ;
//			DXST_LOGFILEFMT_ADDUTF16LE(( L"%dx%d %dbit color", Mode.Width, Mode.Height, Mode.ColorBitDepth ) ) ;
			if( Mode.Width == Width && Mode.Height == Height && Mode.ColorBitDepth == ColorBitDepth )
				break ;
		}
		if( i == Num )
		{
			DXST_LOGFILEFMT_ADDUTF16LE(( "\xfe\x5b\xdc\x5f\x57\x30\x66\x30\x44\x30\x8b\x30\x3b\x75\x62\x97\xe2\x30\xfc\x30\xc9\x30\x6a\x30\x57\x30\x00"/*@ L"ΉĂʃ[hȂ" @*/ )) ;

			// 640x480 16bit߂ꍇ 32bitĂ݂
			if( Width == 640 && Height == 480 && ColorBitDepth == 16 )
			{
				NS_SetGraphMode( Width, Height, 32, GSYS.Screen.MainScreenRefreshRate ) ;
				goto SCREENMODECHECK ;
			}
		}
	}

	// 24rbgJ[`FbN
	if( DxSysData.NotWinFlag == FALSE )
	{
		int CrBitNum ;

		// ݂̉ʃ[hł̐F̐擾
		{
			HDC hdc ;
			hdc = WinAPIData.Win32Func.GetDCFunc( NULL ) ;
			CrBitNum = WinAPIData.Win32Func.GetDeviceCapsFunc( hdc, PLANES ) * WinAPIData.Win32Func.GetDeviceCapsFunc( hdc, BITSPIXEL ) ;
			WinAPIData.Win32Func.ReleaseDCFunc( NULL, hdc ) ;
		}

		if( ( CrBitNum == 24 && WinData.WindowModeFlag == TRUE ) ||
			( NS_GetColorBitDepth() == 24 ) )
		{
			DXST_LOGFILE_ADDUTF16LE( "\x24\xff\x38\xff\xe9\x30\xa4\x30\xd6\x30\xe9\x30\xea\x30\x6f\x30\x12\xff\x14\xff\xd3\x30\xc3\x30\xc8\x30\xab\x30\xe9\x30\xfc\x30\xe2\x30\xfc\x30\xc9\x30\x6b\x30\xfe\x5b\xdc\x5f\x57\x30\x66\x30\x44\x30\x7e\x30\x5b\x30\x93\x30\x0a\x00\x00"/*@ L"cwCu͂QSrbgJ[[hɑΉĂ܂\n" @*/ ) ;

			DXST_LOGFILE_TABSUB ;
			DXST_LOGFILEFMT_ERRCODE_ADDUTF16LE(( DX_ERRORCODE_WIN_DESKTOP_24BIT_COLOR, "\x24\xff\x38\xff\xe9\x30\xa4\x30\xd6\x30\xe9\x30\xea\x30\x6e\x30\x1d\x52\x1f\x67\x16\x53\xe6\x51\x06\x74\x31\x59\x57\x65\x00"/*@ L"cwCȕs" @*/ ) ) ;
			return -1 ;
		}
	}

#endif // DX_NON_GRAPHICS

	// ptH[}XJE^[̏
	{
		// ptH[}XJE^[̎g擾
		WinAPIData.Win32Func.QueryPerformanceFrequencyFunc( ( LARGE_INTEGER * )&WinData.PerformanceClock ) ;

		// g邩ǂۑĂ
		WinData.PerformanceTimerFlag = WinData.PerformanceClock != 0 ;
	}
	
	// VXeOo
	OutSystemInfo() ;

#ifndef DX_NON_GRAPHICS
	// ftHg̃OtBbN֐o^
	NS_SetRestoreGraphCallback( NULL ) ;
#endif // DX_NON_GRAPHICS

	// en̏
	InitializeCom() ;											// bnl̏
	if( InitializeWindow() == -1 ) goto ERROR_DX ;				// EChE֌W̏
#ifndef DX_NON_NETWORK
#if 0
	if( HTTP_Initialize() == -1 ) goto ERROR_DX ;				// HTTP ֌W̏̏
#endif
#endif

	if( DxSysData.NotInputFlag == FALSE )
	{
#ifndef DX_NON_INPUT
		if( InitializeInputSystem() == -1 ) goto ERROR_DX ;			// ̓VXȅ
#endif // DX_NON_INPUT
	}

	if( DxSysData.NotSoundFlag == FALSE )
	{
#ifndef DX_NON_SOUND
		InitializeSoundConvert() ;									// TEhϊ̏
		InitializeSoundSystem() ;									// TEhVXê̏
#endif // DX_NON_SOUND
	}
	if( DxSysData.NotDrawFlag == FALSE )
	{
		InitializeBaseImageManage() ;
#ifndef DX_NON_SOFTIMAGE
		InitializeSoftImageManage() ;
#endif // DX_NON_SOFTIMAGE
#ifndef DX_NON_MOVIE
		InitializeMovieManage() ;
#endif

#ifndef DX_NON_GRAPHICS
		if( Graphics_Initialize() < 0 ) goto ERROR_DX ;
#endif // DX_NON_GRAPHICS
	}
#ifndef DX_NON_INPUTSTRING
	InitializeInputCharBuf() ;									// R[hobt@̏
#endif // DX_NON_INPUTSTRING

	// cwCutOĂ
	DxSysData.DxLib_InitializeFlag = TRUE ;

	// urxmb҂
//	NS_SetWaitVSyncFlag( TRUE ) ;

	// tXN[[hꍇEChEőOʂɎĂ
	if( WinData.WindowModeFlag == FALSE && WinData.UserWindowFlag == FALSE )
		SetAbsoluteForegroundWindow( WinData.MainWindow ) ;
	
#if !defined( DX_NON_LOG ) && !defined( DX_NON_PRINTF_DX )
	// Oo͏̏s
	InitializeLog() ;
#endif

#ifndef DX_NON_GRAPHICS
	// `̕ύX
	NS_SetDrawScreen( DX_SCREEN_BACK ) ;
	NS_SetDrawScreen( DX_SCREEN_FRONT ) ;
#endif // DX_NON_GRAPHICS

	if( DxSysData.NotDrawFlag == FALSE )
	{
#ifndef DX_NON_MODEL
		// fo[WP̏
		if( MV1Initialize() < 0 )
		{
			goto ERROR_DX ;
		}
#endif
	}

	// tO|
	DxSysData.DxLib_RunInitializeFlag = FALSE ;

	// EChẼTCYLǂ̃tO|NGXgĂtO|
	if( WinData.WindowSizeValidResetRequest == TRUE )
	{
		WinData.WindowSizeValid = FALSE ;
	}

	DXST_LOGFILE_TABSUB ;
	DXST_LOGFILEFMT_ADDUTF16LE(( "\x24\xff\x38\xff\xe9\x30\xa4\x30\xd6\x30\xe9\x30\xea\x30\x6e\x30\x1d\x52\x1f\x67\x16\x53\xe6\x51\x06\x74\x42\x7d\x86\x4e\x00"/*@ L"cwCȕI" @*/ ) ) ;

	// I
	return 0 ;

ERROR_DX:
	NS_DxLib_End() ;

	DXST_LOGFILE_TABSUB ;
	DXST_LOGFILEFMT_ADDUTF16LE(( "\x24\xff\x38\xff\xe9\x30\xa4\x30\xd6\x30\xe9\x30\xea\x30\x6e\x30\x1d\x52\x1f\x67\x16\x53\xe6\x51\x06\x74\x31\x59\x57\x65\x00"/*@ L"cwCȕs" @*/ ) ) ;

	// tO|
	DxSysData.DxLib_RunInitializeFlag = FALSE ;

	return -1 ;
} 

// Cugp̏I֐
extern int NS_DxLib_End( void )
{
	// ɏIsĂ邩AĂȂꍇ͉Ȃ
	if( DxSysData.DxLib_InitializeFlag == FALSE ) return 0;

	SETUP_WIN_API

	WinData.AltF4_EndFlag = 1 ;

#ifndef DX_NON_SOFTIMAGE
	// o^SẴ\tgC[W폜
	InitSoftImage() ;
#endif // DX_NON_SOFTIMAGE

	// en̏I
#if !defined( DX_NON_LOG ) && !defined( DX_NON_PRINTF_DX )
	TerminateLog() ;			// Ǒn
#endif

#ifndef DX_NON_NETWORK
#if 0
	HTTP_Terminate() ;			// HTTP ֌W̏̌ns
#endif
	TerminateNetWork() ;		// vr֌W̏I
#endif

#ifndef DX_NON_SOUND
	NS_StopMusic() ;			// lhchtĂԂ̏ꍇ~߂
#endif // DX_NON_SOUND

#ifndef DX_NON_MODEL
	MV1Terminate() ;			// fo[WP̌n
#if 0
	NS_InitModel() ;			// ff[^̍폜
#endif
#endif

#ifndef DX_NON_GRAPHICS
	Graphics_Terminate() ;
#endif // DX_NON_GRAPHICS

	TerminateBaseImageManage() ;

#ifndef DX_NON_SOFTIMAGE
	TerminateSoftImageManage() ;
#endif // DX_NON_SOFTIMAGE

#ifndef DX_NON_MOVIE
	TerminateMovieManage() ;
#endif

#ifndef DX_NON_INPUT
	TerminateInputSystem() ;	// ̓VXȅI
#endif // DX_NON_INPUT

#ifndef DX_NON_INPUTSTRING
	TerminateInputCharBuf() ;
#endif // DX_NON_INPUTSTRING

#ifndef DX_NON_SOUND
	TerminateSoundSystem() ;	// TEhVXěn
	TerminateSoundConvert() ;	// TEhϊ̏I
#endif // DX_NON_SOUND

	TerminateWindow() ;			// v֌W̏I

	TerminateCom() ;			// bnl̏I

#ifndef DX_NON_LOG
	// Ot@Čn
	LogFileTerminate() ;
#endif

	// cwCutO|
	DxSysData.DxLib_InitializeFlag = FALSE ;

	// pthsbZ[W܂Ń[v
	if( DxSysData.NotWinFlag == FALSE )
		while( NS_ProcessMessage() == 0 && WinData.QuitMessageFlag == FALSE && WinData.DestroyMessageCatchFlag == FALSE ){}

	// EChENX̓o^𖕏
	WinAPIData.Win32Func.UnregisterClassWFunc( WinData.ClassName, WinData.Instance ) ;

	// EChE҂
	while( DxSysData.NotWinFlag == FALSE && WinAPIData.Win32Func.FindWindowWFunc( WinData.ClassName, NULL ) == WinData.MainWindow )
	{
		WinAPIData.Win32Func.DestroyWindowFunc( WinData.MainWindow ) ;
		WinAPIData.Win32Func.SleepFunc( 100 ) ;
	}

	// JgfBNgɖ߂
	DX_FSETDIR( WinData.CurrentDirectory ) ; 

	// A[JCut@CANZXp̃f[^̌n
#ifndef DX_NON_DXA
	DXA_DIR_Terminate() ;
#endif

#ifdef DX_USE_DXLIB_MEM_DUMP
	// _vs
	NS_DxDumpAlloc() ;
#endif

	// ̌ns
	MemoryTerminate() ;

	// WinAPI 
	ReleaseWinAPI() ;

	// I
	return 0 ;
}

// Cu̓ŎgpĂ\̂[āADxLib_Init ̑Oɍsݒ𖳌( DxLib_Init ̑Oł̂ݗL )
extern int NS_DxLib_GlobalStructInitialize( void )
{
//	_MEMSET( &GRA2, 0, sizeof( GRA2 ) ) ;
#ifndef DX_NON_GRAPHICS
	_MEMSET( &GraphicsSysData, 0, sizeof( GraphicsSysData ) );
#endif // DX_NON_GRAPHICS

	_MEMSET( &BaseImageManage, 0, sizeof( BaseImageManage ) ) ;
	_MEMSET( &WinData, 0, sizeof( WinData ) );
#ifndef DX_NON_SOUND
	_MEMSET( &SoundSysData, 0, sizeof( SoundSysData ) );
#endif // DX_NON_SOUND

	return 0;
}

// EChEỸbZ[W[vɑ鏈s
extern int NS_ProcessMessage( void )
{
	int	EventCon ;
	int LoopCount ;
	MSG msg = { 0 } ;
	int Flag = FALSE, hr, hr2, StopCheckFlag ;
	static int EndFlag = FALSE ;

	// tOĂȂɂI
	if( EndFlag )
	{
		return 0 ;
	}

	SETUP_WIN_API

	// ProcessMessage stO𗧂Ă
	WinData.ProcessMessageFlag = TRUE ;

	// NCAg̈悩oȂ悤ɂݒŁANCAg̈ɋoȂ悤ɂ
	if( WinData.NotMoveMousePointerOutClientAreaFlag && WinData.ActiveFlag && WinData.WindowMinSizeFlag == FALSE && WinData.WindowModeFlag && WinData.SetClipCursorFlag == FALSE )
	{
		POINT MousePos ;

		WinAPIData.Win32Func.GetCursorPosFunc( &MousePos ) ;
		if( WinData.WindowRect.left < MousePos.x && MousePos.x <= WinData.WindowRect.right &&
			WinData.WindowRect.top  < MousePos.y && MousePos.y <= WinData.WindowRect.bottom )
		{
			WinData.SetClipCursorFlag = TRUE ;
			WinAPIData.Win32Func.ClipCursorFunc( &WinData.WindowRect ) ;
		}
	}

	// DxSysData.NotWinFlag Ăꍇ̓EChE֘Ȁ͍sȂ
	if( DxSysData.NotWinFlag == FALSE )
	{
		// EChE쐬ĂȂ牽I
		if( WinData.MainWindow == NULL ) goto END ;

		// cwCu쐬EChEgpĂꍇ̂݃bZ[Ws
		if( WinData.UserWindowFlag == FALSE )
		{
			// EChE[hύXtOĂEChE[hύX鏈s
			if( WinData.ChangeWindowModeFlag == TRUE && WinData.UseChangeWindowModeFlag == TRUE && WinData.MainThreadID == WinAPIData.Win32Func.GetCurrentThreadIdFunc() )
			{
				// tO|
				WinData.ChangeWindowModeFlag = FALSE ;

				// EChE[hύX
				NS_ChangeWindowMode( WinData.WindowModeFlag == TRUE ? FALSE : TRUE ) ;

				// R[obN֐Ă
				if( WinData.ChangeWindowModeCallBackFunction != NULL ) 
					WinData.ChangeWindowModeCallBackFunction( WinData.ChangeWindowModeCallBackFunctionData ) ;
			}

			// bZ[WȂꍇүނ̏I܂Ń[vij
			EventCon = 0 ;
			LoopCount = 0 ;
			StopCheckFlag = FALSE ;
			while(
				(
				  WinData.CloseMessagePostFlag == FALSE &&
				  WinData.WM_ACTIVATE_StockNum == 0 &&
				  WinData.NonActiveRunFlag     == FALSE &&
				  (
				    WinData.ActiveFlag == FALSE ||
				    WinData.WindowMinSizeFlag == TRUE
				  ) 
				) ||
				(
				  Flag == FALSE &&
				  WinData.QuitMessageFlag == FALSE
				)
			)
			{
				// \tgANeBuɂȂ~ꍇ͎ۑĂ
				if( StopCheckFlag == FALSE && ( WinData.ActiveFlag == FALSE || WinData.WindowMinSizeFlag == TRUE ) && WinData.NonActiveRunFlag == FALSE )
				{
					StopCheckFlag = TRUE ;
					WinData.WaitTime = NS_GetNowCount() ;
					WinData.WaitTimeValidFlag = TRUE ;
				}

				Flag = TRUE ;

				if( ( WinData.ActiveFlag == FALSE || WinData.WindowMinSizeFlag == TRUE ) && WinData.NonActiveRunFlag == FALSE )
				{
					WinAPIData.Win32Func.SleepFunc( 1 ) ;

					// ScreenCopy ̃NGXgtOĂ莞Ԃo߂Ă ScreenCopy s
					if( WinData.ScreenCopyRequestFlag == TRUE && NS_GetNowCount() - WinData.ScreenCopyRequestStartTime > 1000 / 60 * 4 )
					{
#ifndef DX_NON_GRAPHICS
						// ANeBȕꍇ͔ANeBuɕ\p̉摜ꍇ͗ʂ̃Rs[͍sȂ
						if( WinData.PauseGraph.GraphData == NULL )
						{
							NS_ScreenCopy() ;
						}
#endif // DX_NON_GRAPHICS
						WinData.ScreenCopyRequestStartTime = NS_GetNowCount() ;
						WinData.ScreenCopyRequestFlag = FALSE ;
					}
				}

				hr  = 1 ;
				hr2 = 0 ;
				while( hr )
				{
					MSG msg2 ;
					if(
//						( hr2 = ( WinAPIData.Win32Func.PeekMessageWFunc( &msg2, NULL, 0, 0, PM_NOREMOVE ) != 0 && msg2.message == WM_SYSCOMMAND && msg2.wParam == SC_SCREENSAVE ) ) ||
						( hr2 = ( WinAPIData.Win32Func.PeekMessageWFunc( &msg2,       NULL, 0, 0, PM_NOREMOVE ) != 0 /*&& msg2.message == WM_SYSCOMMAND && msg2.wParam == SC_SCREENSAVE*/ ) ) != 0 || // ATOK̏ꍇXN[Z[o[bZ[WɌ肷Ɣp^SpL[œ{̓[hɈڍsłȂ̂ŁAɁB肪炻̂Ƃl悤EEE
						( hr  = ( WinAPIData.Win32Func.PeekMessageWFunc( &msg,  ( HWND )-1, 0, 0, PM_REMOVE   ) || WinAPIData.Win32Func.PeekMessageWFunc( &msg, WinData.MainWindow, 0, 0, PM_REMOVE ) ) ) != 0
					  )
					{
						if( hr2 != 0 )
						{
							WinAPIData.Win32Func.PeekMessageWFunc( &msg2, NULL, 0, 0, PM_REMOVE ) ;
							msg = msg2 ;
						}

						// _CAO{bNXp̃bZ[Wׂ
						if( WinData.DialogBoxHandle == NULL || WinAPIData.Win32Func.IsDialogMessageWFunc( WinData.DialogBoxHandle, &msg ) == 0 )
						{
							// _CAO{bNX̃bZ[Wł͂Ȃ畁ʂɏ
							// (EChE[h̎̂)
							if( msg.message == WM_ACTIVATEAPP && WinData.WindowModeFlag == TRUE )
							{
								// ANeBuǂۑ
								WinData.ActiveFlag = LOWORD( msg.wParam ) ;
							}

							if( WinData.QuitMessageFlag ) goto R1 ;
							if( msg.message == WM_QUIT ) 
							{
								WinData.QuitMessageFlag = TRUE ;
								DxLib_EndRequest() ;
							}

							// ANZ[^Lȏꍇ̓ANZ[^L[
							if( WinAPIData.Win32Func.TranslateAcceleratorWFunc( WinData.MainWindow, WinData.Accel, &msg ) == 0 )
							{
//								DXST_LOGFILEFMT_ADDUTF16LE(( L"DispatchMessage\n" )) ;

								// ANZ[^L[bZ[Wł͂Ȃ畁ʂɏ
								WinAPIData.Win32Func.TranslateMessageFunc( &msg );
								WinAPIData.Win32Func.DispatchMessageWFunc( &msg );
							}
							EventCon ++ ;
//							if ( EventCon >= MAX_EVENTPROCESS_NUM )
//							{
//								EventCon = 0 ;
//								Flag = TRUE ;
//
//								goto R2;
//							}

							Flag = FALSE ;
						}
						else
						{
							Flag = FALSE ;
						}
					}

					// _CAO{bNX̃bZ[W
					if( WinData.DialogBoxHandle != NULL )
					{
						if( WinAPIData.Win32Func.PeekMessageWFunc( &msg, WinData.DialogBoxHandle, 0, 0, PM_REMOVE ) )
						{
							WinAPIData.Win32Func.IsDialogMessageWFunc( WinData.DialogBoxHandle, &msg );
						}
					}

					// qEChẼbZ[W
					{
						int i ;

						for( i = 0 ; i < WinData.MesTakeOverWindowNum ; i ++ )
						{
							if( WinAPIData.Win32Func.PeekMessageWFunc( &msg, WinData.MesTakeOverWindow[i], 0, 0, PM_REMOVE ) )
							{
								WinAPIData.Win32Func.TranslateMessageFunc( &msg );
								WinAPIData.Win32Func.DispatchMessageWFunc( &msg );
							}
						}
					}
				}

//		R2 :
				if( ( WinData.ActiveFlag == FALSE || WinData.WindowMinSizeFlag == TRUE ) && WinData.NonActiveRunFlag == FALSE )
				{
					// ֌W̎Is
					MemoryProcess() ;

#ifndef DX_NON_NETWORK
					// ʐM֌W̃bZ[Ws
					NS_ProcessNetMessage( TRUE ) ;

#if 0
					// HTTP s
					HTTP_ProcessAll() ;
#endif
#endif

#ifndef DX_NON_SOUND

#ifndef DX_NON_MULTITHREAD
					if( WinData.ProcessorNum <= 1 )
#endif // DX_NON_MULTITHREAD
					{
						// TEh̎Is
						NS_ProcessStreamSoundMemAll() ;
						ST_SoftSoundPlayerProcessAll() ;
						ProcessPlay3DSoundMemAll() ;
					}
					ProcessPlayFinishDeleteSoundMemAll() ;
#endif // DX_NON_SOUND

#ifndef DX_NON_GRAPHICS
					// `揈̃bZ[W[vɍsׂs
					Graphics_Win_MessageLoop_Process() ;
#endif // DX_NON_GRAPHICS

#ifndef DX_NON_ASYNCLOAD
					// CXbh񓯊ǂݍ݂̏s
					ProcessASyncLoadRequestMainThread() ;
#endif // DX_NON_ASYNCLOAD

					WinAPIData.Win32Func.SleepFunc( 24 ) ;
				}

				if( WinData.QuitMessageFlag ) goto R1 ;

				// CXbhł͂Ȃ璼
				if( WinData.MainThreadID != WinAPIData.Win32Func.GetCurrentThreadIdFunc() ) break ;

				// DxLib_End Ă΂Ă烋[vPOŔ
				LoopCount ++ ;
				if( WinData.AltF4_EndFlag && LoopCount >= 10 )
					break ;
			}

		R1 :
			// j[LɂȂĂƂ̏
			if( WinData.MainThreadID == WinAPIData.Win32Func.GetCurrentThreadIdFunc() )
			{
				// j[Iɕ\\ɂ肷
				// tOĂꍇ͂̏s
				if( WinData.NotMenuAutoDisplayFlag == FALSE )
					MenuAutoDisplayProcess() ;

				// L[{[h̓͏ԂXV
	//			UpdateKeyboardInputState() ;
			}

			// j[LɂȂĂƂ̏
		/*	{
				// Ƀj[sĂ邩Aj[ꍇ͉Ȃ
				if( DxSysData.DxLib_InitializeFlag == TRUE && WinData.MenuUseFlag == TRUE && WinData.MenuShredRunFlag == FALSE )
				{
					int Key ;

					// GXP[vL[w̃L[ꂽ烁j[Jn
					Key = ( WinData.MenuStartKey == 0 ) ? KEY_INPUT_ESCAPE : WinData.MenuStartKey ;
					if( CheckHitKey( Key ) == 1 )
					{
						MenuProcess() ;
					}
				}
			}
		*/
			// bNw肪烍bN
		/*	if( WinData.SysCommandOffFlag == TRUE )
			{
				if( WinData.LockInitializeFlag == TRUE )
				{
					LockSetForegroundWindow( LSFW_LOCK ) ;
					WinData.LockInitializeFlag = FALSE ;
				}
			}
		*/
		}

		// WM_ACTIVATE bZ[W̃NGXgꍇ͂ŏ
		if( WinData.CloseMessagePostFlag == FALSE )
		{
			while( WinData.WM_ACTIVATE_StockNum != 0 )
			{
				WPARAM wParam ;
				LPARAM lParam ;
				int APPMes ;

				wParam = WinData.WM_ACTIVATE_wParam[ WinData.WM_ACTIVATE_StartIndex ] ;
				lParam = WinData.WM_ACTIVATE_lParam[ WinData.WM_ACTIVATE_StartIndex ] ;
				APPMes = WinData.WM_ACTIVATE_APPMes[ WinData.WM_ACTIVATE_StartIndex ] ;
				WinData.WM_ACTIVATE_StartIndex = ( WinData.WM_ACTIVATE_StartIndex + 1 ) % 512 ;
				WinData.WM_ACTIVATE_StockNum -- ;
				WM_ACTIVATEProcess( wParam, lParam, APPMes ) ;
			}
		}
	}

	// t@C̎Is
//	ReadOnlyFileAccessProcessAll() ;

#ifndef DX_NON_SOUND

#ifndef DX_NON_MULTITHREAD
	if( WinData.ProcessorNum <= 1 )
#endif // DX_NON_MULTITHREAD
	{
		// TEh̎Is
		NS_ProcessStreamSoundMemAll() ;
		ST_SoftSoundPlayerProcessAll() ;
		ProcessPlay3DSoundMemAll() ;
	}
	ProcessPlayFinishDeleteSoundMemAll() ;
#endif // DX_NON_SOUND

#ifndef DX_NON_GRAPHICS
	// `揈̃bZ[W[vɍsׂs
	Graphics_Win_MessageLoop_Process() ;
#endif // DX_NON_GRAPHICS

#ifndef DX_NON_ASYNCLOAD
	// CXbh񓯊ǂݍ݂̏s
	if( WinData.QuitMessageFlag == FALSE )
	{
		ProcessASyncLoadRequestMainThread() ;
	}
#endif // DX_NON_ASYNCLOAD

	// t̎Is
#ifndef DX_NON_SOUND
	NS_ProcessMusicMem() ;
#endif // DX_NON_SOUND

#ifndef DX_NON_INPUT
	// L[{[h̎Is
	//KeyboradBufferProcess() ;

	// L[{[h͂̍XVs
	UpdateKeyboardInputState( FALSE ) ;

	// pbh̎Is
	JoypadEffectProcess() ;
#endif // DX_NON_INPUT

#ifndef DX_NON_NETWORK
	// ʐM֌W̃bZ[Ws
	NS_ProcessNetMessage( TRUE ) ;

#if 0
	// HTTP s
	HTTP_ProcessAll() ;
#endif
#endif

	// ֌W̎Is
	MemoryProcess() ;

#ifndef DX_NON_KEYEX
	// L[͏s
	{
		// tOĂ
		EndFlag = TRUE ;

		NS_ProcessActKeyInput() ;

		// tO|
		EndFlag = FALSE ;
	}
#endif
END :

	// ProcessMessage stO|
	WinData.ProcessMessageFlag = FALSE ;

	return WinData.QuitMessageFlag == TRUE ? -1 : 0 ;
}










// G[֐

// G[
extern int DxLib_Error( const wchar_t *ErrorStr )
{
	// G[O̔ro
	DXST_LOGFILE_ADDW( ErrorStr ) ;
	DXST_LOGFILE_ADDW( L"\n" ) ;

	// en̏I
	NS_DxLib_End() ;

	SETUP_WIN_API

#if defined( DX_THREAD_SAFE ) || defined( DX_THREAD_SAFE_NETWORK_ONLY )
	// NeBJZNVƃCxgnh
	if( WinData.DxConflictWaitThreadIDInitializeFlag == TRUE )
	{
		int i ;

		// tO|
		WinData.DxConflictWaitThreadIDInitializeFlag = FALSE ;

		// ՓˎɎgpCxg̉
		for( i = 0 ; i < MAX_THREADWAIT_NUM ; i ++ )
		{
			if( WinData.DxConflictWaitThreadID[i][1] != 0 )
				WinAPIData.Win32Func.CloseHandleFunc( (HANDLE)WinData.DxConflictWaitThreadID[i][1] ) ;
			WinData.DxConflictWaitThreadID[i][1] = 0 ;
		}

		// NeBJZNV폜
		CriticalSection_Delete( &WinData.DxConflictCheckCriticalSection ) ;
	}
#endif // defined( DX_THREAD_SAFE ) || defined( DX_THREAD_SAFE_NETWORK_ONLY )

//	while( WinData.QuitMessageFlag == FALSE && NS_ProcessMessage() == 0 ){}

//	DXST_LOGFILE_ADDW( L"\tgG[I܂" ) ;
	WinAPIData.Win32Func.ExitProcessFunc( (DWORD)-1 ) ;

	return -1 ;
}

// CũG[s( UTF16LE )
extern int DxLib_ErrorUTF16LE( const char *ErrorStr )
{
	int Result ;

	CHAR_TO_WCHAR_T_STRING_BEGIN( ErrorStr )
	CHAR_TO_WCHAR_T_STRING_SETUP( ErrorStr, return -1, DX_CHARCODEFORMAT_UTF16LE )

	Result = DxLib_Error( UseErrorStrBuffer ) ;

	CHAR_TO_WCHAR_T_STRING_END( ErrorStr )

	return Result ;
}

































// JE^yю擾n֐

// ~bPʂ̐xJE^̌ݒl𓾂
extern int NS_GetNowCount( int /*UseRDTSCFlag*/ )
{
#if 0
#ifndef DX_NON_INLINE_ASM
	//  RDTSC ͎gpȂ(bԕӂ̃JEg𐳊mɎ擾ɂ͎Ԃ|߂āAN
	// ̑Ɍq)
//	if( WinData.UseRDTSCFlag == TRUE && UseRDTSCFlag == TRUE && DxSysData.DxLib_InitializeFlag == TRUE )
	if( FALSE )
	{
		LARGE_INTEGER Clock ;

#ifdef __BCC
		unsigned int low, high ;
		unsigned int lowP, highP ;
		
		lowP = (unsigned int)&low ;
		highP = (unsigned int)&high ;

		__asm
		{
			db		0x0f
			db		0x31
			MOV		EDI, lowP
			MOV		[EDI], EAX
			MOV		EDI, highP
			MOV		[EDI], EDX
//			MOV		low , EAX
//			MOV		high , EDX
		}
		
		Clock.LowPart = low ;
		Clock.HighPart = high ;
#else
		__asm
		{
//			db		0fh
//			db		031h
		RDTSC
			MOV		Clock.LowPart , EAX
			MOV		Clock.HighPart , EDX
		}
#endif
		return ( int )( _DTOL( ( double )Clock.QuadPart * 1000.0 / WinData.OneSecCount ) & 0x7fffffff ) ;
	}
	else
#endif // DX_NON_INLINE_ASM
#endif // 0
	{
		SETUP_WIN_API

		if( WinAPIData.Win32Func.WinMMDLL == NULL )
		{
			LoadWinAPI() ;
			if( WinAPIData.Win32Func.WinMMDLL == NULL )
			{
				return -1 ;
			}
		}

		return ( int )( WinAPIData.Win32Func.timeGetTimeFunc() & 0x7fffffff ) ;
	}
}

// GetNowTime̍xo[W
extern LONGLONG NS_GetNowHiPerformanceCount( int /*UseRDTSCFlag*/ )
{
	LONGLONG Result, MulNum ;
	unsigned int /*FPUStatus,*/ Temp[4] ;

#if 0
#ifndef DX_NON_INLINE_ASM
//	FPUStatus = 0x00020000 ;
	//  RDTSC ͎gpȂ(bԕӂ̃JEg𐳊mɎ擾ɂ͎Ԃ|߂āAN
	// ̑Ɍq)
//	if( WinData.UseRDTSCFlag == TRUE && UseRDTSCFlag == TRUE && DxSysData.DxLib_InitializeFlag == TRUE )
	if( FALSE )
	{
		LARGE_INTEGER Clock ;

#ifdef __BCC
		unsigned int low, high ;
		unsigned int lowP, highP ;
		
		lowP = (unsigned int)&low ;
		highP = (unsigned int)&high ;

		__asm
		{
			db		0x0f
			db		0x31
			MOV		EDI, lowP
			MOV		[EDI], EAX
			MOV		EDI, highP
			MOV		[EDI], EDX
//			MOV		low , EAX
//			MOV		high , EDX
		}

		Clock.LowPart = low ;
		Clock.HighPart = high ;
#else
		__asm
		{
		RDTSC
			MOV		Clock.LowPart, EAX
			MOV		Clock.HighPart, EDX
		}
#endif
		// xݒグ
//		FPUStatus = _control87( 0x00000000, 0x00030000 ) ;
		MulNum = 1000000;
		_MUL128_1( (DWORD *)&MulNum, (DWORD *)&Clock.QuadPart, (DWORD *)Temp );
		_DIV128_1( (DWORD *)Temp, (DWORD *)&WinData.OneSecCount, (DWORD *)&Result );
//		Result = _DTOL64( ( double )Clock.QuadPart * 1000000.0 / WinData.OneSecCount ) ;
	}
	else
#endif  // DX_NON_INLINE_ASM
#endif // 0
	{
		SETUP_WIN_API

		if( WinData.PerformanceTimerFlag )
		{
			LONGLONG NowTime ;

			// ptH[}XJE^JEg𓾂
			WinAPIData.Win32Func.QueryPerformanceCounterFunc( ( LARGE_INTEGER * )&NowTime ) ;

//			// xݒグ
//			FPUStatus = _control87( 0x00000000, 0x00030000 ) ;
			MulNum = 1000000;
			_MUL128_1( (DWORD *)&MulNum, (DWORD *)&NowTime, (DWORD *)Temp );
			_DIV128_1( (DWORD *)Temp, (DWORD *)&WinData.PerformanceClock, (DWORD *)&Result );
//			Result = ( LONGLONG )_DTOL64( ( double )NowTime / ( double )WinData.PerformanceClock * 1000000.0 ) ;
		}
		else
		{
			if( WinAPIData.Win32Func.WinMMDLL == NULL )
				return -1 ;

			// ptH[}XJE^Ȃꍇ͒ʏ̃JE^ɂPOOO|lԂ
//			Result = ( LONGLONG )_DTOL64( (double)WinAPIData.Win32Func.timeGetTimeFunc() * 1000 ) ;
			MulNum = 1000;
			((DWORD *)&Result)[0] = (DWORD)WinAPIData.Win32Func.timeGetTimeFunc();
			((DWORD *)&Result)[1] = 0;
			_MUL128_1( (DWORD *)&MulNum, (DWORD *)&Result, (DWORD *)Temp );
			((DWORD *)&Result)[0] = Temp[0];
			((DWORD *)&Result)[1] = Temp[1];
		}
	}

	// xݒɖ߂
//	_control87( FPUStatus, 0x00030000 ) ;

	return Result ;
}

// ݎ擾
extern int NS_GetDateTime( DATEDATA *DateBuf )
{
	SYSTEMTIME LocalTime ;

	SETUP_WIN_API

	// [J𓾂	
	WinAPIData.Win32Func.GetLocalTimeFunc( &LocalTime ) ;
	
	// [Jf[^ɐp̃f[^^f[^Ɏɉh
	DateBuf->Year	= LocalTime.wYear ;
	DateBuf->Mon	= LocalTime.wMonth ;
	DateBuf->Day	= LocalTime.wDay ;
	DateBuf->Hour	= LocalTime.wHour ;
	DateBuf->Min	= LocalTime.wMinute ;
	DateBuf->Sec	= LocalTime.wSecond ;

	// I
	return 0 ;
}







// 擾

#ifndef DX_NON_MERSENNE_TWISTER

// ̏lݒ肷
extern int NS_SRand( int Seed )
{
	// lZbg
	srandMT( ( unsigned long )Seed ) ;

	// I
	return 0 ;
}

// 擾( RandMax : Ԃėl̍ől )
extern int NS_GetRand( int RandMax )
{
	int Result ;
	LONGLONG RandMaxLL ;

	RandMaxLL = RandMax ;
	RandMaxLL ++ ;
	Result = ( int )( ( ( LONGLONG )randMT() * RandMaxLL ) >> 32 ) ;

	return Result ;
}

#else // DX_NON_MERSENNE_TWISTER

// ̏lݒ肷
extern int NS_SRand( int Seed )
{
	// lZbg
	srand( Seed ) ;

	// I
	return 0 ;
}

// 擾( RandMax : Ԃėl̍ől )
extern int NS_GetRand( int RandMax )
{
	int Result ;
	LONGLONG RandMaxLL ;

	RandMaxLL = RandMax ;
	RandMaxLL ++ ;
	Result = ( int )( ( ( LONGLONG )rand() * RandMaxLL ) / ( ( LONGLONG )RAND_MAX + 1 ) ) ;

	return Result ;
}

#endif // DX_NON_MERSENNE_TWISTER



// obe[֘A

// dr̎cʂ % Ŏ擾( ߂lF 100=t[d  0=[dcʖ )
extern int NS_GetBatteryLifePercent( void )
{
	SYSTEM_POWER_STATUS SystemPowerStatus ;

	SETUP_WIN_API

	if( WinAPIData.Win32Func.GetSystemPowerStatusFunc == NULL )
	{
		return -1 ;
	}

	if( WinAPIData.Win32Func.GetSystemPowerStatusFunc( &SystemPowerStatus ) == 0 )
	{
		return -1 ;
	}

	if( SystemPowerStatus.ACLineStatus == AC_LINE_ONLINE )
	{
		return 100 ;
	}

	if( SystemPowerStatus.BatteryLifePercent == BATTERY_PERCENTAGE_UNKNOWN )
	{
		return -1 ;
	}

	return SystemPowerStatus.BatteryLifePercent ;
}




// Nbv{[h֌W

#ifdef UNICODE
	#define CLIPBOARD_TEXT CF_UNICODETEXT
#else
	#define CLIPBOARD_TEXT CF_TEXT
#endif

// Nbv{[hɊi[ĂeLXgf[^ǂݏoA-1 ̏ꍇ̓Nbv{[hɃeLXgf[^͖Ƃ( DestBuffer  NULL nƊi[ɕKvȃf[^TCYԂĂ )
extern int GetClipboardText_PF( TCHAR *DestBuffer )
{
	HGLOBAL Mem ;
	void *SrcBuffer ;

	SETUP_WIN_API

	// Nbv{[hI[v
	if( WinAPIData.Win32Func.OpenClipboardFunc( WinData.MainWindow ) == 0 )
		return -1 ;

	// Nbv{[hɊi[Ăf[^eLXgf[^ǂ擾
	if( WinAPIData.Win32Func.IsClipboardFormatAvailableFunc( CLIPBOARD_TEXT ) == 0 )
	{
		WinAPIData.Win32Func.CloseClipboardFunc() ;
		return -1 ;
	}

	// Nbv{[hɊi[ĂeLXgf[^̃nh擾
	Mem = WinAPIData.Win32Func.GetClipboardDataFunc( CLIPBOARD_TEXT ) ;

	// o̓obt@ NULL ̏ꍇ̓eLXgf[^̃TCYԂ
	if( DestBuffer == NULL )
	{
		SIZE_T Size ;

		Size = WinAPIData.Win32Func.GlobalSizeFunc( Mem ) + 1 ;
		WinAPIData.Win32Func.CloseClipboardFunc() ;
		return ( int )Size ;
	}

	// o̓obt@ɃeLXgf[^Rs[
	SrcBuffer = WinAPIData.Win32Func.GlobalLockFunc( Mem ) ;
	_TSTRCPY( DestBuffer, ( TCHAR * )SrcBuffer ) ;
	WinAPIData.Win32Func.GlobalUnlockFunc( Mem ) ;
	WinAPIData.Win32Func.CloseClipboardFunc() ;

	// I
	return 0 ;
}

// Nbv{[hɊi[ĂeLXgf[^ǂݏoA-1 ̏ꍇ̓Nbv{[hɃeLXgf[^͖Ƃ( DestBuffer  NULL nƊi[ɕKvȃf[^TCYԂĂ )
extern int GetClipboardText_WCHAR_T_PF( wchar_t *DestBuffer )
{
	HGLOBAL Mem ;
	void *SrcBuffer ;

	SETUP_WIN_API

	// Nbv{[hI[v
	if( WinAPIData.Win32Func.OpenClipboardFunc( WinData.MainWindow ) == 0 )
		return -1 ;

	// Nbv{[hɊi[Ăf[^eLXgf[^ǂ擾
	if( WinAPIData.Win32Func.IsClipboardFormatAvailableFunc( CF_UNICODETEXT ) == 0 )
	{
		WinAPIData.Win32Func.CloseClipboardFunc() ;
		return -1 ;
	}

	// Nbv{[hɊi[ĂeLXgf[^̃nh擾
	Mem = WinAPIData.Win32Func.GetClipboardDataFunc( CF_UNICODETEXT ) ;

	// o̓obt@ NULL ̏ꍇ̓eLXgf[^̃TCYԂ
	if( DestBuffer == NULL )
	{
		SIZE_T Size ;

		Size = WinAPIData.Win32Func.GlobalSizeFunc( Mem ) + 1 ;
		WinAPIData.Win32Func.CloseClipboardFunc() ;
		return ( int )Size ;
	}

	// o̓obt@ɃeLXgf[^Rs[
	SrcBuffer = WinAPIData.Win32Func.GlobalLockFunc( Mem ) ;
	_WCSCPY( DestBuffer, ( wchar_t * )SrcBuffer ) ;
	WinAPIData.Win32Func.GlobalUnlockFunc( Mem ) ;
	WinAPIData.Win32Func.CloseClipboardFunc() ;

	// I
	return 0 ;
}

// Nbv{[hɃeLXgf[^i[
extern int SetClipboardText_WCHAR_T_PF( const wchar_t *Text )
{
	HGLOBAL Mem ;
	void *Buffer ;
	int Len ;

	SETUP_WIN_API

	// ̒擾
	Len = ( int )_WCSLEN( Text ) ;

	// i[郁̈̊m
	Mem = WinAPIData.Win32Func.GlobalAllocFunc( GMEM_FIXED, ( Len + 1 ) * sizeof( wchar_t ) ) ;

	// mۂ̈Ɋi[
	Buffer = WinAPIData.Win32Func.GlobalLockFunc( Mem ) ;
	_WCSCPY( ( wchar_t * )Buffer, Text ) ;
	WinAPIData.Win32Func.GlobalUnlockFunc( Mem ) ;

	// Nbv{[hI[v
	if( WinAPIData.Win32Func.OpenClipboardFunc( WinData.MainWindow ) )
	{
		// Nbv{[hɕi[
		WinAPIData.Win32Func.EmptyClipboardFunc() ;
		WinAPIData.Win32Func.SetClipboardDataFunc( CF_UNICODETEXT, Mem ) ;
		WinAPIData.Win32Func.CloseClipboardFunc() ;
	}
	else
	{
		// ̉
		WinAPIData.Win32Func.GlobalFreeFunc( Mem ) ;
	}

	// I
	return 0 ;
}













#ifndef DX_NON_NAMESPACE

}

#endif // DX_NON_NAMESPACE





